#############################################################################
##
#W    simplicialhomology.gd   share package 'homology'      Dumas, Heckenbach
##
##==========================================================
## Homology Groups in GAP 4
## (c) July 1999
##==========================================================

#==========================================================
# Information level
#==========================================================
DeclareGlobalFunction ("HomologyInfo");

#==================================================
# Available algorithms
#==================================================
DeclareGlobalVariable ("HomologyAlgorithms");
DeclareGlobalVariable ("EliminateAlgorithm");
DeclareGlobalVariable ("EliminateGMPAlgorithm");
DeclareGlobalVariable ("ValenceElimAlgorithm");
DeclareGlobalVariable ("ValenceBBAlgorithm");
DeclareGlobalFunction ("SetHomologyAlgorithm");

#==================================================
# Error tolerance for the Valence algorithm
#==================================================
DeclareGlobalFunction ("SetUncertaintyTolerance");

#==================================================
# Available output formats
#==================================================
DeclareGlobalVariable ("HomologyGroupFormats");
DeclareGlobalVariable ("CyclicPSubgroups");
DeclareGlobalVariable ("MaximalCyclicSubgroups");
DeclareGlobalVariable ("GapFormat");
DeclareGlobalFunction ("SetHomologyGroupFormat");

#==================================================
# A Simplicial complex is a dense list of dense lists
#==================================================
DeclareGlobalFunction ("IsSimplicialComplex");

#==================================================
# Computing information about simplicial complexes
#==================================================
DeclareGlobalFunction ("SimplicialHomology");
DeclareGlobalFunction ("SimplicialBettiNumbers");
DeclareGlobalFunction ("SimplicialNTorsionRanks");
DeclareGlobalFunction ("SimplicialBoundaryMaps");
DeclareGlobalFunction ("SimplicialComplexDimension");
