// ==========================================================================
// $Source: /users/huron/gautier/projets/CVS/Givaro/src/kernel/integer/givintcstor.C,v $
// Copyright(c)'94-97 by Givaro Team
// see the copyright file.
// Authors: M. Samama, T. Gautier
// $Id: givintcstor.C,v 1.0.0.1 1999/04/15 10:13:49 gautier Exp $
// ==========================================================================
#include <iostream.h>
#include "givinteger.h"
#include "givcompgmp.h"


//------------------------------------- predefined null and one
const Integer Integer::zero = givNoInit();
const Integer Integer::one  = givNoInit();

// -- Cstor for Zero and One to delay initialization after the main
Integer::Integer( const givNoInit gi) { mpz_init( (mpz_ptr)&gmp_rep ); }


// -- Integer(const char *s)
Integer::Integer(const char *s) 
{
  mpz_init_set_str((mpz_ptr)&gmp_rep, s, 10);
}

Integer& Integer::copy(const Integer &n)
{
  if (this == &n) return *this;
  mpz_set ( (mpz_ptr)&gmp_rep, (mpz_ptr)&(n.gmp_rep)) ;
  return *this;
}

void Integer::Init(int* argc, char***argv) {
    mpz_init_set_ui ( (mpz_ptr)& ( ((Integer&)zero).gmp_rep ), 0UL);
    mpz_init_set_ui ( (mpz_ptr)& ( ((Integer&)one).gmp_rep ), 1UL);
}

void Integer::End() {
    mpz_clear ( (mpz_ptr)& ( ((Integer&)zero).gmp_rep ) );
    mpz_clear ( (mpz_ptr)& ( ((Integer&)one).gmp_rep ) );
}
