// ==========================================================================
// file: givpowers.h 
// Time-stamp: <16 Dec 99 18:53:32 Jean-Guillaume.Dumas@imag.fr>
// (c) 1999 Givaro Team
// ==========================================================================

#ifndef _GIVARO_POWER_H_
#define _GIVARO_POWER_H_

// -------------------------------------------------------------
// Powering
// -------------------------------------------------------------

template<class TT, class UU> TT mod_power(const TT n, const UU l) {
  if (l == 0) return 1 ;

  unsigned long p = l ;
  short is_assg = 0 ;

  unsigned long res = 1L ;
  unsigned long puiss  = n ;

  while (p != 0) {
    if (p & 0x1) 
        if (is_assg) 
           res *= puiss ;
        else { 
           is_assg = 1 ; 
           res = puiss ; 
        }    if ((p >>= 1) != 0) puiss = puiss * puiss ;
  }
  return res ;
}

template<class D, class TT> TT& dom_power(TT& res, const TT& n, long l, const D& F) {
  if (l == 0) return res = F.one ;

  unsigned long p = l ;
  short is_assg = 0 ;

  res = F.one ;
  TT puiss = n, tmp ;

  while (p != 0) {
    if (p & 0x1) 
        if (is_assg) {
           F.mulin(res,puiss) ;
        } else { 
           is_assg = 1 ; 
           res = puiss ; 
        }
    if ((p >>= 1) != 0) { F.mul(tmp,puiss,puiss) ; puiss = tmp; }
  } 
  return res ;
}

#include <math.h>

template<> double mod_power(const double a, const double e) {
   return pow(a,e);
}

#endif
